package cloud.linktime.market.common;

import com.alibaba.fastjson.JSON;
import org.apache.commons.lang3.StringUtils;

import javax.servlet.http.HttpServletRequest;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by anna on 2019/6/13.
 */
public class Util {

  public static String getRedisServer(){
    String redis_server = Constant.DEFAULT_REDIS_SERVER;
    String env_redis_server = System.getenv(Constant.SERVER_REDIS);
    if(StringUtils.isNotBlank(env_redis_server)){
      redis_server = env_redis_server;
    }
    return redis_server;
  }

  public static String getRedisGoodsKey(){
    String env_krb5_user = System.getenv(Constant.KRB5_USER);

    if(StringUtils.isEmpty(env_krb5_user)){
      env_krb5_user = "";
    }else{
      env_krb5_user += "_";
    }

    String redis_goods_key = env_krb5_user + Constant.GOODS_KEY;
    return redis_goods_key;
  }

  public static String getRedisStoreKey(){
    String env_krb5_user = System.getenv(Constant.KRB5_USER);

    if(StringUtils.isEmpty(env_krb5_user)){
      env_krb5_user = "";
    }else{
      env_krb5_user += "_";
    }

    String redis_store_key = env_krb5_user + Constant.STORE_KEY;
    return redis_store_key;
  }

  public static String getRedisInventoryKey(){
    String env_krb5_user = System.getenv(Constant.KRB5_USER);

    if(StringUtils.isEmpty(env_krb5_user)){
      env_krb5_user = "";
    }else{
      env_krb5_user += "_";
    }

    String redis_inventory_key = env_krb5_user + Constant.INVENTORY_KEY;
    return redis_inventory_key;
  }


  public static String getRedisOrderDay(){
    String env_krb5_user = System.getenv(Constant.KRB5_USER);

    if(StringUtils.isEmpty(env_krb5_user)){
      env_krb5_user = "";
    }else{
      env_krb5_user += "_";
    }

    String redis_key = env_krb5_user + Constant.SUM_ORDER_DAY;
    return redis_key;
  }

  public static String getRedisPaymentDay(){
    String env_krb5_user = System.getenv(Constant.KRB5_USER);

    if(StringUtils.isEmpty(env_krb5_user)){
      env_krb5_user = "";
    }else{
      env_krb5_user += "_";
    }

    String redis_key = env_krb5_user + Constant.SUM_PAYMENT_DAY;
    return redis_key;
  }

  public static String getResidStoreAmountCountMinute(){
    String env_krb5_user = System.getenv(Constant.KRB5_USER);

    if(StringUtils.isEmpty(env_krb5_user)){
      env_krb5_user = "";
    }else{
      env_krb5_user += "_";
    }

    String redis_key = env_krb5_user + Constant.SUM_STORE_AMOUNT_COUNT_MINUTE;
    return redis_key;
  }

  public static String returnFromJson(String flag, Object data, String msg){
    Map dataMap = new HashMap<>();
    dataMap.put("status", flag);
    dataMap.put("data", data);
    dataMap.put("message", msg);
    String result = JSON.toJSONString(dataMap);
    return result;
  }

  public static BigDecimal keep2decimals(String value,int point){
    BigDecimal bg = new BigDecimal(value).setScale(point, RoundingMode.UP);
    return bg;
  }

  public static int getLimit(HttpServletRequest request){
    int limit = 10;
    String limitString = request.getParameter("limit");
    if (StringUtils.isNotBlank(limitString)){
      limit = Integer.valueOf(limitString);
    }
    return limit;
  }

  public static String getArea(HttpServletRequest request){
    String queryArea = request.getParameter("area");
    if (StringUtils.isEmpty(queryArea)){
      queryArea = Constant.ALL;
    }
    return queryArea;
  }

  public static void main(String[] args) {
  }
}
